
/** @class_declaration satReparaciones */
//////////////////////////////////////////////////////////////////
//// MODULO SAT REPARACIONES /////////////////////////////////////
class satReparaciones extends oficial {
  var REPARACIONES:Number;
  function satReparaciones( context ) { oficial( context ); }
  function init() { return this.ctx.satReparaciones_init(); }
  function datosRep(codigo:String) {
	return this.ctx.satReparaciones_datosRep(codigo);
  }
  function crearTabla() {
         return this.ctx.satReparaciones_crearTabla();
  }
  function tblDocsClicked(row:Number, col:Number) {
        return this.ctx.satReparaciones_tblDocsClicked(row, col);
   }
   function verDocumento() {
        return this.ctx.satReparaciones_verDocumento();
   }
  function dibOrigenRep(codigo:String, fila:Number):Number {
	return this.ctx.satReparaciones_dibOrigenRep(codigo, fila);
  }
  function dibDestinoRep(codigo:String, fila:Number):Number {
	return this.ctx.satReparaciones_dibDestinoRep(codigo, fila);
  }
  function dibOrigenAlbCli(codigo:String, fila:Number):Number {
	return this.ctx.satReparaciones_dibOrigenAlbCli(codigo, fila);
  }
  function cargarTraza() {
	return this.ctx.satReparaciones_cargarTraza();
  }
}
//// MODULO SAT REPARACIONES /////////////////////////////////////
//////////////////////////////////////////////////////////////////

/** @class_definition satReparaciones */
/////////////////////////////////////////////////////////////////
//// MODULO SAT REPARACIONES ////////////////////////////////////

function satReparaciones_init()
{
  this.iface.__init();
}
function satReparaciones_crearTabla()
{
    var numeroColumnas;
    var etiquetaColumnas;
    numeroColumnas = 8;
    etiquetaColumnas = "Presupuestos/Pedidos/Albaranes/Facturas/Recibos/Pagos/Pagos/Reparacin";
    this.iface.PRESUPUESTOS = 0;
    this.iface.PEDIDOS = 1;
    this.iface.ALBARANES = 2;
    this.iface.FACTURAS = 3;
    this.iface.RECIBOS = 4;
    this.iface.PAGOS = 5;
    this.iface.PAGOS_ID = 6;
    this.iface.REPARACIONES=7;
    this.iface.tblDocs.setNumCols(numeroColumnas);
      for (var i=0; i<numeroColumnas; i++)
        {
         this.iface.tblDocs.setColumnWidth(i, 100);
        }

    this.iface.tblDocs.hideColumn(6);
    this.iface.tblDocs.setColumnLabels("/",etiquetaColumnas);
    this.iface.filaActual = 0;
}


function satReparaciones_cargarTraza()
{
  var cursor:FLSqlCursor = this.cursor();
  var tipo:String = cursor.valueBuffer("tipo");
  var codigo:String = cursor.valueBuffer("codigo");
  switch (tipo) {
	case "sat_reparaciones": {
          this.iface.tblDocs.insertRows(this.iface.tblDocs.numRows());
          this.iface.tblDocs.setText(0,this.iface.REPARACIONES,codigo);
          this.iface.filaActual = this.iface.dibDestinoRep(codigo, this.iface.filaActual);
          this.iface.filaActual = this.iface.dibOrigenRep(codigo, this.iface.filaActual);
	  this.iface.clienteProveedor = "cliente";
	  break;
	}
    //    case "albaranescli": {
     //     this.iface.dibOrigenAlbCli(codigo, 0);
      //  }
	default: {
	  this.iface.__cargarTraza();
	}
  }
}

/** \D Muestra los datos principales del reparacin indicado
@param	codigo: Cdigo de la reparacin
\end */
function satReparaciones_datosRep(codigo:String)
{
	var util:FLUtil = new FLUtil;
	var qry:FLSqlQuery = new FLSqlQuery();
	with (qry) {
		setTablesList("sat_reparaciones");
		setSelect("codcliente, nombre, total, fecha");
		setFrom("sat_reparaciones");
		setWhere("codreparacion = '" + codigo + "'");
		setForwardOnly(true);
	}
	if (!qry.exec())
		return false;
	if (!qry.first())
		return false;

	var texto:String = util.translate("scripts", "Reparacin %1\nCliente %2 - %3\nImporte: %4 \nFecha: %5").arg(codigo).arg(qry.value("codcliente")).arg(qry.value("nombre")).arg(util.roundFieldValue(qry.value("total"), "sat_reparaciones", "total")).arg(util.dateAMDtoDMA(qry.value("fecha")));
	this.child("lblDatosDoc").text = texto;
}

/** \D Muestra los datos del documento seleccionado
\end */
function satReparaciones_tblDocsClicked(row:Number, col:Number)
{
        var codigo:String;
        codigo = this.iface.tblDocs.text(row, col);
        if (!codigo || codigo == "") {
                this.child("lblDatosDoc").text = "";
                this.child("pbnVerDocumento").enabled = false;
                return;
        }

        switch (col) {
                case this.iface.REPARACIONES: {
                        this.iface.datosRep(codigo);
                        this.child("pbnVerDocumento").enabled = true;
                        break;
                }
                default: {
                        this.iface.__tblDocsClicked(row, col);
                }

        }
}

function satReparaciones_verDocumento()
{
        var columna:Number = this.iface.tblDocs.currentColumn();
        var fila:Number = this.iface.tblDocs.currentRow();

        var codigo:String;
        if (columna == this.iface.PAGOS)
                return;

        codigo = this.iface.tblDocs.text(fila, columna);
        if (!codigo || codigo == "")
                return;

        var cursor:FLSqlCursor;
        switch (columna) {
                case this.iface.REPARACIONES: {
                        cursor = new FLSqlCursor("sat_reparaciones");
                        cursor.select("codreparacion = '" + codigo + "'");
                        if (!cursor.first())
                            return false;
                        cursor.browseRecord();
                        break;
                }
                                   default: {
                                              this.iface.__verDocumento();
                }
                        }
}



/** Dibuja los pedidos que originan el albarn de cliente indicado, a partir de la fila de la tabla indicada
@param	codigo: Cdigo del albarn
@param	fila: Fila en la que comenzar a dibujar
@return	ltima fila dibujada
\end */
function satReparaciones_dibOrigenAlbCli(codigo:String, fila:Number):Number
{
  var qryReparaciones:FLSqlQuery = new FLSqlQuery();
  with (qryReparaciones) {
	setTablesList("sat_reparaciones,albaranescli");
        setSelect("s.codreparacion");
	setFrom("sat_reparaciones s INNER JOIN albaranescli a ON s.idalbaran = a.idalbaran");
        setWhere("a.codigo = '" + codigo + "' GROUP BY s.codreparacion ORDER BY s.codreparacion");
	setForwardOnly(true);
  }
  if (!qryReparaciones.exec())
	return this.iface.__dibOrigenAlbCli(codigo, fila);

  if (!qryReparaciones.size())
	return this.iface.__dibOrigenAlbCli(codigo, fila);

  while (qryReparaciones.next()) {
	fila++;
	if (this.iface.tblDocs.numRows() == fila) {
	  this.iface.tblDocs.insertRows(fila);
	}
	this.iface.tblDocs.setText(fila, this.iface.REPARACIONES, qryReparaciones.value("s.codreparacion"));
	fila = this.iface.dibOrigenRep(qryReparaciones.value("s.codreparacion"), fila);
	if (fila == -1) {
	  return -1;
	}
  }
  return fila;
}


/** Dibuja los albaranes destino de la reparacin del cliente indicado, a partir de la fila de la tabla indicada
@param	codigo: Cdigo de la reparacin
@param	fila: Fila en la que comenzar a dibujar
@return	ltima fila dibujada
\end */
function satReparaciones_dibDestinoRep(codigo:String, fila:Number):Number
{
  var qryAlbaranes:FLSqlQuery = new FLSqlQuery();
  with (qryAlbaranes) {
	setTablesList("sat_reparaciones,albaranescli,lineasalbaranescli");
	setSelect("a.codigo");
	setFrom("sat_reparaciones s INNER JOIN albaranescli a ON s.idalbaran = a.idalbaran");
	setWhere("s.codreparacion = '" + codigo + "' GROUP BY a.codigo ORDER BY a.codigo");
	setForwardOnly(true);
  }

  if (!qryAlbaranes.exec())
	return -1;
  while (qryAlbaranes.next()) {
	fila++;

	if (this.iface.tblDocs.numRows() == fila)
	  this.iface.tblDocs.insertRows(fila);
	this.iface.tblDocs.setText(fila, this.iface.ALBARANES, qryAlbaranes.value("a.codigo"));
	fila = this.iface.dibDestinoAlbCli(qryAlbaranes.value("a.codigo"), fila);
	if (fila == -1)
	  return -1;
  }
  return fila;
}

function satReparaciones_dibOrigenRep(codigo:String, fila:Number):Number
{
  return fila;
}
//// MODULO SAT REPARACIONES ////////////////////////////////////
/////////////////////////////////////////////////////////////////

